#
# Copyright (C) 2007 - 2008 M <optimizationkit@gmail.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# OptimizationKit - configuration file parser

from xml.etree.ElementTree import Element, SubElement, ElementTree, parse

def ret_conf_value(i):
	for o, v in i.items():
		if (o == "value") and (len(v) > 0):
			value = v
	return value

def read_config_cfs_opts(el):
	cfs_opts = {"cfs_sched_nice":"NULL", "cfs_sched_batch_wakeup_granularity_ns":"NULL",
	"cfs_sched_min_granularity_ns":"NULL", "cfs_sched_runtime_limit_ns":"NULL",
	"cfs_sched_stat_granularity_ns":"NULL", "cfs_sched_wakeup_granularity_ns":"NULL",
	"cfs_sched_latency_ns":"NULL", "cfs_sched_migration_cost":"NULL",
	"cfs_sched_rt_period_us":"NULL", "cfs_sched_rt_runtime_us":"NULL"}

	for i in el:
		if i.tag == "cfs_sched_nice":
			cfs_opts["cfs_sched_nice"] = ret_conf_value(i)
		if i.tag == "cfs_sched_batch_wakeup_granularity_ns":
			cfs_opts["cfs_sched_batch_wakeup_granularity_ns"] = ret_conf_value(i)
		if i.tag == "cfs_sched_latency_ns":
			cfs_opts["cfs_sched_latency_ns"] = ret_conf_value(i)
		if i.tag == "cfs_sched_migration_cost":
			cfs_opts["cfs_sched_migration_cost"] = ret_conf_value(i)
		if i.tag == "cfs_sched_min_granularity_ns":
			cfs_opts["cfs_sched_min_granularity_ns"] = ret_conf_value(i)
		if i.tag == "cfs_sched_rt_period_us":
			cfs_opts["cfs_sched_rt_period_us"] = ret_conf_value(i)
		if i.tag == "cfs_sched_rt_runtime_us":
			cfs_opts["cfs_sched_rt_runtime_us"] = ret_conf_value(i)
		if i.tag == "cfs_sched_runtime_limit_ns":
			cfs_opts["cfs_sched_runtime_limit_ns"] = ret_conf_value(i)
		if i.tag == "cfs_sched_stat_granularity_ns":
			cfs_opts["cfs_sched_stat_granularity_ns"] = ret_conf_value(i)
		if i.tag == "cfs_sched_wakeup_granularity_ns":
			cfs_opts["cfs_sched_wakeup_granularity_ns"] = ret_conf_value(i)

#	print "cfs_opts = %s\n" % cfs_opts

	return cfs_opts

def read_config_cfq_opts(el):
	cfq_opts = {"cfq_sched_nice":"NULL", "cfq_sched_back_seek_max":"NULL",
	"cfq_sched_back_seek_penalty":"NULL", "cfq_sched_fifo_expire_async":"NULL",
	"cfq_sched_fifo_expire_sync":"NULL", "cfq_sched_quantum":"NULL",
	"cfq_sched_slice_async":"NULL", "cfq_sched_slice_async_rq":"NULL",
	"cfq_sched_slice_idle":"NULL", "cfq_sched_slice_sync":"NULL"}

	for i in el:
		if i.tag == "cfq_sched_nice":
			cfq_opts["cfq_sched_nice"] = ret_conf_value(i)
		if i.tag == "cfq_sched_back_seek_max":
			cfq_opts["cfq_sched_back_seek_max"] = ret_conf_value(i)
		if i.tag == "cfq_sched_back_seek_penalty":
			cfq_opts["cfq_sched_back_seek_penalty"] = ret_conf_value(i)
		if i.tag == "cfq_sched_fifo_expire_async":
			cfq_opts["cfq_sched_fifo_expire_async"] = ret_conf_value(i)
		if i.tag == "cfq_sched_fifo_expire_sync":
			cfq_opts["cfq_sched_fifo_expire_sync"] = ret_conf_value(i)
		if i.tag == "cfq_sched_quantum":
			cfq_opts["cfq_sched_quantum"] = ret_conf_value(i)
		if i.tag == "cfq_sched_slice_async":
			cfq_opts["cfq_sched_slice_async"] = ret_conf_value(i)
		if i.tag == "cfq_sched_fifo_expire_async":
			cfq_opts["cfq_sched_fifo_expire_async"] = ret_conf_value(i)
		if i.tag == "cfq_sched_slice_async_rq":
			cfq_opts["cfq_sched_slice_async_rq"] = ret_conf_value(i)
		if i.tag == "cfq_sched_slice_idle":
			cfq_opts["cfq_sched_slice_idle"] = ret_conf_value(i)
		if i.tag == "cfq_sched_slice_sync":
			cfq_opts["cfq_sched_slice_sync"] = ret_conf_value(i)

#	print "cfq_opts = %s\n" % cfq_opts

	return cfq_opts

def read_config_anticipatory_opts(el):
	anticipatory_opts = {"anticipatory_sched_antic_expire":"NULL", "anticipatory_sched_read_batch_expire":"NULL",
	"anticipatory_sched_read_expire":"NULL", "anticipatory_sched_write_batch_expire":"NULL",
	"anticipatory_sched_write_expire":"NULL"}

	for i in el:
		if i.tag == "anticipatory_sched_antic_expire":
			anticipatory_opts["anticipatory_sched_antic_expire"] = ret_conf_value(i)
		if i.tag == "anticipatory_sched_read_batch_expire":
			anticipatory_opts["anticipatory_sched_read_batch_expire"] = ret_conf_value(i)
		if i.tag == "anticipatory_sched_read_expire":
			anticipatory_opts["anticipatory_sched_read_expire"] = ret_conf_value(i)
		if i.tag == "anticipatory_sched_write_batch_expire":
			anticipatory_opts["anticipatory_sched_write_batch_expire"] = ret_conf_value(i)
		if i.tag == "anticipatory_sched_write_expire":
			anticipatory_opts["anticipatory_sched_write_expire"] = ret_conf_value(i)

#	print "anticipatory_opts = %s\n" % anticipatory_opts

	return anticipatory_opts

def read_config_deadline_opts(el):
	deadline_opts = {"deadline_sched_fifo_batch":"NULL", "deadline_sched_front_merges":"NULL",
	"deadline_sched_read_expire":"NULL", "deadline_sched_write_expire":"NULL",
	"deadline_sched_writes_starved":"NULL"}

	for i in el:
		if i.tag == "deadline_sched_fifo_batch":
			deadline_opts["deadline_sched_fifo_batch"] = ret_conf_value(i)
		if i.tag == "deadline_sched_front_merges":
			deadline_opts["deadline_sched_front_merges"] = ret_conf_value(i)
		if i.tag == "deadline_sched_read_expire":
			deadline_opts["deadline_sched_read_expire"] = ret_conf_value(i)
		if i.tag == "deadline_sched_write_expire":
			deadline_opts["deadline_sched_write_expire"] = ret_conf_value(i)
		if i.tag == "deadline_sched_writes_starved":
			deadline_opts["deadline_sched_writes_starved"] = ret_conf_value(i)

#	print "deadline_opts = %s\n" % deadline_opts

	return deadline_opts

def read_config_cgroup_opts(el):
	cgroup_opts = {"cpuset.cpu_exclusive":"NULL", "cpuset.cpus":"NULL", "cpuset.mem_exclusive":"NULL",
	"cpuset.memory_migrate":"NULL", "cpuset.memory_pressure":"NULL", "cpuset.memory_pressure_enabled":"NULL",
	"cpuset.memory_spread_page":"NULL", "cpuset.memory_spread_slab":"NULL", "cpuset.mems":"NULL",
	"cpuset.sched_load_balance":"NULL", "notify_on_release":"NULL", "memory.limit_in_bytes":"NULL",
	"cfq.ioprio":"NULL"}

	for i in el:
		if i.tag == "cpuset.cpu_exclusive":
			cgroup_opts["cpuset.cpu_exclusive"] = ret_conf_value(i)
		if i.tag == "cpuset.cpus":
			cgroup_opts["cpuset.cpus"] = ret_conf_value(i)
		if i.tag == "cpuset.mem_exclusive":
			cgroup_opts["cpuset.mem_exclusive"] = ret_conf_value(i)
		if i.tag == "cpuset.memory_migrate":
			cgroup_opts["cpuset.memory_migrate"] = ret_conf_value(i)
		if i.tag == "cpuset.memory_pressure":
			cgroup_opts["cpuset.memory_pressure"] = ret_conf_value(i)
		if i.tag == "cpuset.memory_pressure_enabled":
			cgroup_opts["cpuset.memory_pressure_enabled"] = ret_conf_value(i)
		if i.tag == "cpuset.memory_spread_page":
			cgroup_opts["cpuset.memory_spread_page"] = ret_conf_value(i)
		if i.tag == "cpuset.memory_spread_slab":
			cgroup_opts["cpuset.memory_spread_slab"] = ret_conf_value(i)
		if i.tag == "cpuset.mems":
			cgroup_opts["cpuset.mems"] = ret_conf_value(i)
		if i.tag == "cpuset.sched_load_balance":
			cgroup_opts["cpuset.sched_load_balance"] = ret_conf_value(i)
		if i.tag == "notify_on_release":
			cgroup_opts["notify_on_release"] = ret_conf_value(i)
		if i.tag == "memory.limit_in_bytes":
			cgroup_opts["memory.limit_in_bytes"] = ret_conf_value(i)
		if i.tag == "cfq.ioprio":
			cgroup_opts["cfq.ioprio"] = ret_conf_value(i)

#	print "cgroup_opts = %s\n" % cgroup_opts

	return cgroup_opts

def read_config_class(element):
	for o, v in element.items():
		if o == "name":
			sched_class_name = v
		if o == "prio":
			sched_class_prio = v

	apps = []
	users = []
	groups = []
	cfs_opts = "NULL"
	cfq_opts = "NULL"
	anticipatory_opts = "NULL"
	deadline_opts = "NULL"
	cgroup_opts = "NULL"

	for el in element:
		if el.tag == "scheduler":
			value = ret_conf_value(el)
			if value == "cfs":
				cfs_opts = read_config_cfs_opts(el)
			if value == "cfq":
				cfq_opts = read_config_cfq_opts(el)
			if value == "anticipatory":
				anticipatory_opts = read_config_anticipatory_opts(el)
			if value == "deadline":
				deadline_opts = read_config_deadline_opts(el)
		if el.tag == "cgroup":
			cgroup_opts = read_config_cgroup_opts(el)
		if el.tag == "user":
			for o, v in el.items():
				if o == "uname" and (len(v) > 0):
					users.append(v)
		if el.tag == "group":
			for o, v in el.items():
				if o == "gname" and (len(v) > 0):
					groups.append(v)
		if el.tag == "app":
			for o, v in el.items():
				if o == "bin" and (len(v) > 0):
					apps.append(v)

	sched_class_descriptor = [sched_class_name, sched_class_prio, cfs_opts,
			cfq_opts, anticipatory_opts, deadline_opts, cgroup_opts, users, groups, apps]

	return sched_class_descriptor

def read_config(config_file):
	config = []
	mode = 0 #default mode
	cpu_exclusive = 0
	mem_exclusive = 0
	cgroup_mount_dir = "/dev/cgroup"
	config_file = ElementTree(file = config_file)
	iter = config_file.getiterator()
	for element in iter:
		if element.tag == "sched_class":
			sched_class_descriptor = read_config_class(element)
			config.append(sched_class_descriptor)
		if element.tag == "mode":
			mode = ret_conf_value(element)
			mode = int(mode)
		if element.tag == "cpu_exclusive":
			cpu_exclusive = ret_conf_value(element)
		if element.tag == "mem_exclusive":
			mem_exclusive = ret_conf_value(element)

	opts = {"mode":mode,"cpu_exclusive":cpu_exclusive,"mem_exclusive":mem_exclusive,"cgroup_mount_dir":cgroup_mount_dir}

	configuration = [opts, config]

	return configuration

def write_config(configuration, config_file_name):
	opts = configuration[0]
	f = open(config_file_name, "w")
	f.write("<cf>\n")

	if int(opts["mode"]) in range(0,5):
		string = str("\t<mode value=\"" + str(opts["mode"]) + "\" />\n")
	else:
		string = str("\t<mode value=\"0\" />\n")
	f.write(string)

	if int(opts["cpu_exclusive"]) in range(0,2):
		string = str("\t<cpu_exclusive value=\"" + str(opts["cpu_exclusive"]) + "\" />\n")
	else:
		string = str("\t<cpu_exclusive value=\"0\" />\n")
	f.write(string)

	if int(opts["mem_exclusive"]) in range(0,2):
		string = str("\t<mem_exclusive value=\"" + str(opts["mem_exclusive"]) + "\" />\n")
	else:
		string = str("\t<mem_exclusive value=\"0\" />\n")
	f.write(string)

	if len(opts["cgroup_mount_dir"]) > 0:
		string = str("\t<cgroup_mount_dir value=\"" + str(opts["cgroup_mount_dir"]) + "\" />\n")
	else:
		string = str("\t<cgroup_mount_dir value=\"/dev/cgroup/\" />\n")
	f.write(string)

	for sched_class in configuration[1]:
		string = str("\n\t<sched_class name=\"" + str(sched_class[0]) + "\" prio=\"" + str(sched_class[1]) + "\">\n")
		f.write(string)

		if sched_class[2] != "NULL":
			f.write("\t\t<scheduler value=\"cfs\">\n")
			for i in sched_class[2]:
				string = str("\t\t\t<" + str(i) + " value=\"" + str(sched_class[2][i]) + "\" />\n")
				f.write(string)
			f.write("\t\t</scheduler>\n")

		if sched_class[3] != "NULL":
			f.write("\n\t\t<scheduler value=\"cfq\">\n")
			for i in sched_class[3]:
				string = str("\t\t\t<" + str(i) + " value=\"" + str(sched_class[3][i]) + "\" />\n")
				f.write(string)
			f.write("\t\t</scheduler>\n")

		if sched_class[4] != "NULL":
			f.write("\n\t\t<scheduler value=\"anticipatory\">\n")
			for i in sched_class[4]:
				string = str("\t\t\t<" + str(i) + " value=\"" + str(sched_class[4][i]) + "\" />\n")
				f.write(string)
			f.write("\t\t</scheduler>\n")

		if sched_class[5] != "NULL":
			f.write("\n\t\t<scheduler value=\"deadline\">\n")
			for i in sched_class[5]:
				string = str("\t\t\t<" + str(i) + " value=\"" + str(sched_class[5][i]) + "\" />\n")
				f.write(string)
			f.write("\t\t</scheduler>\n")

		if sched_class[6] != "NULL":
			f.write("\n\t\t<cgroup>\n")
			for i in sched_class[6]:
				string = str("\t\t\t<" + str(i) + " value=\"" + str(sched_class[6][i]) + "\" />\n")
				f.write(string)
			f.write("\t\t</cgroup>\n")

		f.write("\n")

		for user in sched_class[-3]:
			string = str("\t\t<user uname=\"" + str(user) + "\" />\n")
			f.write(string)

		f.write("\n")
		for group in sched_class[-2]:
			string = str("\t\t<group gname=\"" + str(group) + "\" />\n")
			f.write(string)

		f.write("\n")
		for app in sched_class[-1]:
			string = str("\t\t<app bin=\"" + str(app) + "\" />\n")
			f.write(string)

		f.write("\t</sched_class>\n")
	f.write("</cf>\n")
	f.close()