#
# Copyright (C) 2007 - 2008 M <optimizationkit@gmail.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# OptimizationKit - main library

import commands, re, dircache

def show_version():
	print "OptimizationKit \"Naja naja naja!!!\" v0.1.2-rc1"

def check_features():
	features = {"has_cfs":"NULL", "has_cgroups":"NULL", "has_cfq":"NULL", "has_anticipatory":"NULL", "has_deadline":"NULL", "has_cpuset":"NULL", "has_memory":"NULL", "has_cfqcg":"NULL"}

	kver = commands.getoutput('uname -r').split('-')[0]
	kreq = "2.6.23"
	if kver.split(".") >= kreq.split("."):
		features["has_cfs"] = 1

	cgroup = commands.getoutput('cat /proc/filesystems | grep cgroup')
	kreq = "2.6.24"
	if (kver.split(".") >= kreq.split(".")) and (len(cgroup) > 0):
		features["has_cgroups"] = 1

	cpuset = commands.getoutput('cat /proc/cgroups | grep cpuset')
	if (len(cpuset) > 0):
		features["has_cpuset"] = 1

	memory = commands.getoutput('cat /proc/cgroups | grep memory')
	if (len(memory) > 0):
		features["has_memory"] = 1

	cfq_cg = commands.getoutput('cat /proc/cgroups | grep cfq')
	if (len(cfq_cg) > 0):
		features["has_cfqcg"] = 1

	cfq = commands.getoutput('dmesg | grep "io scheduler cfq registered"')
	if len(cfq) > 0:
		features["has_cfq"] = 1

	anticipatory = commands.getoutput('dmesg | grep "io scheduler anticipatory registered"')
	if len(anticipatory) > 0:
		features["has_anticipatory"] = 1

	deadline = commands.getoutput('dmesg | grep "io scheduler deadline registered"')
	if len(deadline) > 0:
		features["has_deadline"] = 1

	return features

def ret_discs(options):
	discs = []

	if options.hdd != None:
		discs = str(options.hdd)
		discs = discs.split(' ')
	else:
		dir_ls = dircache.listdir("/sys/block/")
		for i in dir_ls:
			ch = re.match("^md|^sd|^hd", i)
			if ch != None:
				discs.append(i)

	return discs
