#
# Copyright (C) 2007 - 2008 M <optimizationkit@gmail.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# OptimizationKit - mode 2

from time import sleep
from ok_cg import setup_cgroups, create_groups_from_config, add_tasks_to_cgroup
from ok_opt import *

def start_mode_2(configuration):
	discs = configuration[0]["discs"]
	features = configuration[0]["features"]
	cpu_exclusive = configuration[0]["cpu_exclusive"]
	mem_exclusive = configuration[0]["mem_exclusive"]
	cgroup_mount_dir = configuration[0]["cgroup_mount_dir"]
	lt = configuration[0]["lt"]
	config = configuration[1]
	default_opts = configuration[2]

	winners = [["NULL", -1, -1], ["NULL", -1, -1]]
	snice_tab = []
	default_set = 0

	setup_cgroups(cpu_exclusive, mem_exclusive, features, cgroup_mount_dir)
	create_groups_from_config(config, cgroup_mount_dir)

	while True:
		for i in config:
			add_tasks_to_cgroup(i[0], i[-1], "", cgroup_mount_dir)

		lop = get_list_of_processes()
		winner = ftw_in_lop(config, lop)
		if winner != None:
			default_set = 0
			winners.append(winner)
			if winners[-2][2] != winner[2]:
				print "New process, restoring defaults, optimization."
				restore_default_opts(default_opts)
				for sched_class in config:
					if sched_class[0] == winner[0]:
						snice = opt(sched_class, winner, snice_tab, discs)
						snice_tab.append(snice)
			else:
				print "The same process."
		elif (winner == None and default_set == 0):
			default_set = 1
			print "There is no winner, restoring defaults."
			restore_default_opts(default_opts)

		sleep(lt)
