#
# Copyright (C) 2007 - 2008 M <optimizationkit@gmail.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# OptimizationKit - classic DeskOpt lib

import os, commands
from ok_srv import *

debug = 0

def get_list_of_processes():
	lop = []
	lop_tmp = commands.getoutput('ps -eo pid,comm O com')
	lop_tmp = lop_tmp.split('\n')

	if (debug):
		print "\nlop_tmp = %s\n" % lop_tmp

	for proc in lop_tmp:
		proc = proc.lstrip()
		proc = proc.split(' ')
		tmp = proc[1].split('/')
		tmp = tmp[-1]
		proc = [proc[0], tmp]
		lop.append(proc)

	if (debug):
		print "\nlop = %s\n" % lop

	return lop

# find app in list of processes
def fa_in_lop(app, lop):
	for process in lop:
		if app == process[1]:
#			print "(Function: fa_in_lop) p[0] = %s" % p[0]
			return process[0]
	return 0

# find the winner in list of processes
def ftw_in_lop(config, lop):
	for sched_class in config:
		winner = ["NULL", -1, -1]
		for app in sched_class[-1]:
			ret = fa_in_lop(app, lop)
			if (ret) and sched_class[1] > winner[1]:
				winner = [sched_class[0], sched_class[1], ret]
				return winner

def opt(config, winner, snice_tab, discs):
	print "Optimization: sched_class = %s, class_prio = %s, pid = %s\n" % (winner[0], winner[1], winner[2])
	pid = winner[-1]
	snice = save_old_nice(pid)
	if len(snice_tab) > 0:
		restore_old_nice(snice_tab, pid)

	if config[2] != "NULL":
		nice = config[2]["cfs_sched_nice"]
		if (debug):
			print "\nnice = %s\n" % nice
		if nice != "NULL":
			command = str("renice " + nice + " " + pid + " &>/dev/null")
			os.system(command)

	if config[3] != "NULL":
		nice = config[3]["cfq_sched_nice"]
		if (debug):
			print "\nnice = %s\n" % nice
		if nice != "NULL":
			command = str("ionice " + nice + " -p" + pid + " &>/dev/null")
			os.system(command)

	if config[2] != "NULL":
		change_default_cfs_opts(config[2])

	for disc in discs:
		io_sched = ret_io_sched(disc)
		if io_sched == "cfq" and config[3] != "NULL":
			io_sched_opts = [disc, io_sched, config[3]]
			change_default_cfq_opts(io_sched_opts)
		if io_sched == "anticipatory" and config[4] != "NULL":
			io_sched_opts = [disc, io_sched, config[4]]
			change_default_anticipatory_opts(io_sched_opts)
		if io_sched == "deadline" and config[5] != "NULL":
			io_sched_opts = [disc, io_sched, config[5]]
			change_default_deadline_opts(io_sched_opts)

	if (debug):
		print "(Function: opt) snice = %s" % snice

	return snice
