#
# Copyright (C) 2007 - 2008 M <optimizationkit@gmail.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# OptimizationKit - store, restore, change values

import os, commands

def read_from_file(file):
	if os.path.isfile(file):
		value = commands.getoutput('cat ' + file)
	else:
		value = "NULL"

	return value

def write_to_file(file, value):
	if os.path.isfile(file) and value != "NULL":
		os.system('/bin/echo ' + value + ' > ' + file)

def store_default_cfs_opts():
	cfs_opts = {"cfs_sched_nice":"NULL", "cfs_sched_batch_wakeup_granularity_ns":"NULL",
	"cfs_sched_min_granularity_ns":"NULL", "cfs_sched_runtime_limit_ns":"NULL",
	"cfs_sched_stat_granularity_ns":"NULL", "cfs_sched_wakeup_granularity_ns":"NULL",
	"cfs_sched_latency_ns":"NULL", "cfs_sched_migration_cost":"NULL",
	"cfs_sched_rt_period_us":"NULL", "cfs_sched_rt_runtime_us":"NULL"}

	cfs_opts["cfs_sched_batch_wakeup_granularity_ns"] = read_from_file("/proc/sys/kernel/sched_batch_wakeup_granularity_ns")
	cfs_opts["cfs_sched_latency_ns"] = read_from_file("/proc/sys/kernel/sched_latency_ns")
	cfs_opts["cfs_sched_migration_cost"] = read_from_file("/proc/sys/kernel/sched_migration_cost")
	cfs_opts["cfs_sched_min_granularity_ns"] = read_from_file("/proc/sys/kernel/sched_min_granularity_ns")
	cfs_opts["cfs_sched_rt_period_us"] = read_from_file("/proc/sys/kernel/sched_rt_period_us")
	cfs_opts["cfs_sched_rt_runtime_us"] = read_from_file("/proc/sys/kernel/sched_rt_runtime_us")
	cfs_opts["cfs_sched_runtime_limit_ns"] = read_from_file("/proc/sys/kernel/sched_runtime_limit_ns")
	cfs_opts["cfs_sched_stat_granularity_ns"] = read_from_file("/proc/sys/kernel/sched_stat_granularity_ns")
	cfs_opts["cfs_sched_wakeup_granularity_ns"] = read_from_file("/proc/sys/kernel/sched_wakeup_granularity_ns")

	return cfs_opts

def change_default_cfs_opts(cfs_opts):
	write_to_file("/proc/sys/kernel/sched_batch_wakeup_granularity_ns", cfs_opts["cfs_sched_batch_wakeup_granularity_ns"])
	write_to_file("/proc/sys/kernel/sched_latency_ns", cfs_opts["cfs_sched_latency_ns"])
	write_to_file("/proc/sys/kernel/sched_migration_cost", cfs_opts["cfs_sched_migration_cost"])
	write_to_file("/proc/sys/kernel/sched_min_granularity_ns", cfs_opts["cfs_sched_min_granularity_ns"])
	write_to_file("/proc/sys/kernel/sched_rt_period_us", cfs_opts["cfs_sched_rt_period_us"])
	write_to_file("/proc/sys/kernel/sched_rt_runtime_us", cfs_opts["cfs_sched_rt_runtime_us"])
	write_to_file("/proc/sys/kernel/sched_runtime_limit_ns", cfs_opts["cfs_sched_runtime_limit_ns"])
	write_to_file("/proc/sys/kernel/sched_stat_granularity_ns", cfs_opts["cfs_sched_stat_granularity_ns"])
	write_to_file("/proc/sys/kernel/sched_wakeup_granularity_ns", cfs_opts["cfs_sched_wakeup_granularity_ns"])

def store_default_cfq_opts(disc):
	cfq_opts = {"cfq_sched_nice":"NULL", "cfq_sched_back_seek_max":"NULL",
	"cfq_sched_back_seek_penalty":"NULL", "cfq_sched_fifo_expire_async":"NULL",
	"cfq_sched_fifo_expire_sync":"NULL", "cfq_sched_quantum":"NULL",
	"cfq_sched_slice_async":"NULL", "cfq_sched_slice_async_rq":"NULL",
	"cfq_sched_slice_idle":"NULL", "cfq_sched_slice_sync":"NULL"}

	cfq_opts["cfq_sched_back_seek_max"] = read_from_file("/sys/block/" + disc + "/queue/iosched/back_seek_max")
	cfq_opts["cfq_sched_back_seek_penalty"] = read_from_file("/sys/block/" + disc + "/queue/iosched/back_seek_penalty")
	cfq_opts["cfq_sched_fifo_expire_async"] = read_from_file("/sys/block/" + disc + "/queue/iosched/fifo_expire_async")
	cfq_opts["cfq_sched_fifo_expire_sync"] = read_from_file("/sys/block/" + disc + "/queue/iosched/fifo_expire_sync")
	cfq_opts["cfq_sched_quantum"] = read_from_file("/sys/block/" + disc + "/queue/iosched/quantum")
	cfq_opts["cfq_sched_slice_async"] = read_from_file("/sys/block/" + disc + "/queue/iosched/slice_async")
	cfq_opts["cfq_sched_slice_async_rq"] = read_from_file("/sys/block/" + disc + "/queue/iosched/slice_async_rq")
	cfq_opts["cfq_sched_slice_idle"] = read_from_file("/sys/block/" + disc + "/queue/iosched/slice_idle")
	cfq_opts["cfq_sched_slice_sync"] = read_from_file("/sys/block/" + disc + "/queue/iosched/slice_sync")

	return cfq_opts

def change_default_cfq_opts(io_sched_opts):
	write_to_file("/sys/block/" + io_sched_opts[0] + "/queue/iosched/back_seek_max", io_sched_opts[2]["cfq_sched_back_seek_max"])
	write_to_file("/sys/block/" + io_sched_opts[0] + "/queue/iosched/back_seek_penalty", io_sched_opts[2]["cfq_sched_back_seek_penalty"])
	write_to_file("/sys/block/" + io_sched_opts[0] + "/queue/iosched/fifo_expire_async", io_sched_opts[2]["cfq_sched_fifo_expire_async"])
	write_to_file("/sys/block/" + io_sched_opts[0] + "/queue/iosched/fifo_expire_sync", io_sched_opts[2]["cfq_sched_fifo_expire_sync"])
	write_to_file("/sys/block/" + io_sched_opts[0] + "/queue/iosched/quantum", io_sched_opts[2]["cfq_sched_quantum"])
	write_to_file("/sys/block/" + io_sched_opts[0] + "/queue/iosched/slice_async", io_sched_opts[2]["cfq_sched_slice_async"])
	write_to_file("/sys/block/" + io_sched_opts[0] + "/queue/iosched/slice_async_rq", io_sched_opts[2]["cfq_sched_slice_async_rq"])
	write_to_file("/sys/block/" + io_sched_opts[0] + "/queue/iosched/slice_idle", io_sched_opts[2]["cfq_sched_slice_idle"])
	write_to_file("/sys/block/" + io_sched_opts[0] + "/queue/iosched/slice_sync", io_sched_opts[2]["cfq_sched_slice_sync"])

def store_default_anticipatory_opts(disc):
	anticipatory_opts = {"anticipatory_sched_antic_expire":"NULL", "anticipatory_sched_read_batch_expire":"NULL",
	"anticipatory_sched_read_expire":"NULL", "anticipatory_sched_write_batch_expire":"NULL",
	"anticipatory_sched_write_expire":"NULL"}

	anticipatory_opts["anticipatory_sched_antic_expire"] = read_from_file("/sys/block/" + disc + "/queue/iosched/antic_expire")
	anticipatory_opts["anticipatory_sched_read_batch_expire"] = read_from_file("/sys/block/" + disc + "/queue/iosched/read_batch_expire")
	anticipatory_opts["anticipatory_sched_read_expire"] = read_from_file("/sys/block/" + disc + "/queue/iosched/read_expire")
	anticipatory_opts["anticipatory_sched_write_batch_expire"] = read_from_file("/sys/block/" + disc + "/queue/iosched/write_batch_expire")
	anticipatory_opts["anticipatory_sched_write_expire"] = read_from_file("/sys/block/" + disc + "/queue/iosched/write_expire")

	return anticipatory_opts

def change_default_anticipatory_opts(io_sched_opts):
	write_to_file("/sys/block/" + io_sched_opts[0] + "/queue/iosched/antic_expire", io_sched_opts[2]["anticipatory_sched_antic_expire"])
	write_to_file("/sys/block/" + io_sched_opts[0] + "/queue/iosched/read_batch_expire", io_sched_opts[2]["anticipatory_sched_read_batch_expire"])
	write_to_file("/sys/block/" + io_sched_opts[0] + "/queue/iosched/read_expire", io_sched_opts[2]["anticipatory_sched_read_expire"])
	write_to_file("/sys/block/" + io_sched_opts[0] + "/queue/iosched/write_batch_expire", io_sched_opts[2]["anticipatory_sched_write_batch_expire"])
	write_to_file("/sys/block/" + io_sched_opts[0] + "/queue/iosched/write_expire", io_sched_opts[2]["anticipatory_sched_write_expire"])

def store_default_deadline_opts(disc):
	deadline_opts = {"deadline_sched_fifo_batch":"NULL", "deadline_sched_front_merges":"NULL",
	"deadline_sched_read_expire":"NULL", "deadline_sched_write_expire":"NULL",
	"deadline_sched_writes_starved":"NULL"}

	deadline_opts["deadline_sched_fifo_batch"] = read_from_file("/sys/block/" + disc + "/queue/iosched/fifo_batch")
	deadline_opts["deadline_sched_front_merges"] = read_from_file("/sys/block/" + disc + "/queue/iosched/front_merges")
	deadline_opts["deadline_sched_read_expire"] = read_from_file("/sys/block/" + disc + "/queue/iosched/read_expire")
	deadline_opts["deadline_sched_write_expire"] = read_from_file("/sys/block/" + disc + "/queue/iosched/write_expire")
	deadline_opts["deadline_sched_writes_starved"] = read_from_file("/sys/block/" + disc + "/queue/iosched/writes_starved")

	return deadline_opts

def change_default_deadline_opts(io_sched_opts):
	write_to_file("/sys/block/" + io_sched_opts[0] + "/queue/iosched/fifo_batch", io_sched_opts[2]["deadline_sched_fifo_batch"])
	write_to_file("/sys/block/" + io_sched_opts[0] + "/queue/iosched/front_merges", io_sched_opts[2]["deadline_sched_front_merges"])
	write_to_file("/sys/block/" + io_sched_opts[0] + "/queue/iosched/read_expire", io_sched_opts[2]["deadline_sched_read_expire"])
	write_to_file("/sys/block/" + io_sched_opts[0] + "/queue/iosched/write_expire", io_sched_opts[2]["deadline_sched_write_expire"])
	write_to_file("/sys/block/" + io_sched_opts[0] + "/queue/iosched/writes_starved", io_sched_opts[2]["deadline_sched_writes_starved"])

def ret_io_sched(disc):
	io_sched = commands.getoutput("cat /sys/block/" + disc + "/queue/scheduler")
	io_sched = io_sched.rsplit(']')
	io_sched = io_sched[0]
	io_sched = io_sched.rsplit('[')
	io_sched = io_sched[1]

	return io_sched

def store_default_opts(discs):
	default_cfs_opts = store_default_cfs_opts()

	diosp = []

	for disc in discs:
		io_sched = ret_io_sched(disc)
		if io_sched == "cfq":
			default_cfq_opts = store_default_cfq_opts(disc)
			io = [disc, io_sched, default_cfq_opts]
		elif io_sched == "anticipatory":
			default_anticipatory_opts = store_default_anticipatory_opts(disc)
			io = [disc, io_sched, default_anticipatory_opts]
		elif io_sched == "deadline":
			default_deadline_opts = store_default_deadline_opts(disc)
			io = [disc, io_sched, default_deadline_opts]
		else:
			io = [disc, io_sched, "NULL"]
		diosp.append(io)

	default_opts = [default_cfs_opts, diosp]

	return default_opts

def restore_default_opts(default_opts):

	cfs_opts = default_opts[0]
	change_default_cfs_opts(cfs_opts)

	iso = default_opts[1]
	for io_sched_opts in iso:
		io_sched = ret_io_sched(io_sched_opts[0])
		if io_sched_opts[1] == "cfq" and io_sched == "cfq":
			change_default_cfq_opts(io_sched_opts)
		elif io_sched_opts[1] == "anticipatory" and io_sched == "anticipatory":
			change_default_anticipatory_opts(io_sched_opts)
		elif io_sched_opts[1] == "deadline" and io_sched == "deadline":
			change_default_deadline_opts(io_sched_opts)

def save_old_nice(pid):
	save_t_nice = commands.getoutput('ps -eo pid,ni | grep ' + pid)
	save_t_nice = save_t_nice.split(' ')
	save_t_nice = save_t_nice[-1]
	save_io_nice = commands.getoutput('ionice -p ' + pid)
	save_io_nice = save_io_nice.split(' ')

	if save_io_nice[0] == "realtime:":
		c = 1
	elif save_io_nice[0] == "best-effort:":
		c = 2
	elif save_io_nice[0] == "idle:":
		c = 3
	else:
		# best-effort is default
		c = 2
	c = str(c)
	n = save_io_nice[2]
	n = str(n)
	save_io_nice = str('-c' + c + ' -n' + n)
	snice = [save_t_nice, save_io_nice, pid]

	return snice

def restore_old_nice(snice_tab, pid):
	command = str("renice " + snice_tab[-1][0] + " " + snice_tab[-1][2] + " &>/dev/null")
	os.system(command)
	command = str("ionice " + snice_tab[-1][1] + " -p" + snice_tab[-1][2] + " &>/dev/null")
	os.system(command)